# e3_quneo
Bitwig Studio controller script for KeithMcMillen Quneo


Key Features
------------

    - Pads:
        - Trigger notes with transpose, hold and scales
        - Launch and record clips
        - Split mode: notes and clips simultaneously
    - Sliders: access to fixed sections, parameters pages, macros, 8 track sends and 128 Midi controllers.
    - Transport: play, stop, record. Alternate mode: arm, click, loop
    - Left/right buttons: track navigation, slider target, scale selection.
    - Alternate mode: solo, solo exclusive, mute, track activate, device navigation
    - Rotary sensors: track and master volume Alternate mode: track pan and song tempo
    - All states persistent between sessions


Manual
------

Modes
    The rhombus button switches between modes. The two main modes are note mode and clip launcher mode. A third mode provides
    alternate assignments for many buttons and pads and is active only while the rhombus button is pressed.
    The image shows these alternate assignments below the normal assignments.

Note Mode
    In note mode the pads trigger Midi notes. You can superimpose one of 14 scales on the pads using the "Scale" button pair.
    The scale roots are displayed by a red LED. The "Scales enabled"-button toggles the scale feature. When it is off,
    the pads trigger chromatic notes but still display the selected scale on their LED's.
    The "Octave"-button pair and the "Semitone"-button pair can be used to tranpose the notes.

    Pad Hold Mode
        Besides normal piano style behaviour the pads provide a hold mode which toggles between note-on and note-off
        each time you press a pad. Hold mode is enabled for each pad individually by pressing the pad together
        with the rhombus button. A pad in hold mode is indicated by an orange led.

    Monophonic aftertouch
    By default the pads send monophonic aftertouch in addition to the notes. This can be turned off in the preferences.

Clip Launcher Mode
    Pressing a pad in clip launcher mode starts or stops a clip. The pads are routed to a scrollable 4x4 section
    of the Bitwig clip launcher.

    Recording clips
    To record a clip arm a track and launch an empty slot. Existing clips can be overwritten by pressing the
    rhombus button and a pad simultaneously.

    Split Mode
    The "Split Mode"-button splits the pads into 2 sections. The upper 2 rows will launch clips
    while the lower 2 rows trigger notes.

Slider Routing
    The sliders can be routed to multiple targets. First of all they are always routed to the currently selected device
    of the active track. When you tap the top-target or sub-target buttons you will see notifications popups on the
    Bitwig screen telling the current target of the sliders. You can use the "Track"- and "Device"-buttons to select
    a track and a device. Here is the list of available targets:

    Fixed Section, Common
    Fixed Section, Envelope
    Parameter pages: depends on selected device
    Others, Macros
    Others, Sends
    Others, Midi controllers


Installation
------------

    - Unpack e3_quneo.control.zip into your controller scripts folder.
    - This is ~/Documents/Bitwig Studio/Controller Scripts/ on a Mac computer and %USERPROFILE%\Documents\Bitwig Studio\Controller Scripts on Windows.
    - Load e3_bitwig.quneopreset into any preset slot on the Quneo.
    - In Bitwig open preferences, go to the Controllers tab and click "Detect available controllers".
    - "Keith McMillen Quneo-E3" will show up and after closing the preferences window you can select it in your tracks.


Version History
---------------

    1.01
    - New: Changed layout for rotaries, track pan on rotary 1
    - New: Improved clip indications on pads
    - New: Update LEDs after Quneo preset change
    - Bugfix: Compatibility issue with Bitwig 1.3.6
    - Bugfix: Rotary jumps to zero on first press
    - Bugfix: Scales enable not working<br/>




