

var Leds = function() {};


Leds.prototype.init = function()
{
    //app.sensors.octave.addListener( 'sensorOff', this, this.setPairSensor );
    //app.sensors.semitone.addListener( 'sensorOff', this, this.setPairSensor );
    //app.sensors.scale.addListener( 'sensorOn', this, this.update );
    //app.sensors.scale.addListener( 'sensorOff', this, this.setPairSensor );
    //app.sensors.mode.addListener( 'sensorOff', this, this.setModeSensor );
    //app.preferences.addListener( 'mode', this, this.update );
    //app.preferences.addListener( 'ledsEnabled', this, this.update );

    this.update();
};


Leds.prototype.update = function()
{
    //this.updateSensors();
    this.updatePads();
};


Leds.prototype.onMidi = function( midi )
{
    if( midi.type() === 128 && app.preferences.ledsEnabled )
    {
        var root   = app.getPadRoot();
        var offset = Math.abs( midi.data1 - root );

        if( offset < 16 ) {
            this.setPads( offset, offset + 1 );
        }
    }
};


/**
 * Builds an array of color information for all pads and sends the full array to the pads.
 */
Leds.prototype.updatePads = function()
{
    this.padTable = initArray( 0, 32 );

    if( app.preferences.ledsEnabled === false || app.preferences.mode !== 'notes' ) {  // turn off all pads
        this.setLeds( 0, 32, 0 );
        return;
    }

    var scale       = app.getScale();
    var scaleLength = scale.length;

    if( app.preferences.scalesEnabled )
    {
        for( var i = 0; i < 16; i++ ) {
            i % scaleLength === 0 ? this.setPadRed( i ) : this.setPadGreen( i );
        }
    }
    else {
        this.setLeds( 0, 32, 0 );

        for( var i = 0; i < 16; i++ )
        {
            var index  = i % scaleLength;
            var octave = Math.floor( i / scaleLength );
            var pad    = scale[index] + ( octave * 12 );

            if( pad < 16 ) {
                index === 0 ? this.setPadRed( pad ) : this.setPadGreen( pad );
            }
        }
    }
    this.setPads();
};


Leds.prototype.updateSensors = function()
{
    //this.setPairSensor( app.sensors.octave );
    //this.setPairSensor( app.sensors.semitone );
    //this.setPairSensor( app.sensors.scale );
    //this.setModeSensor();
};


Leds.prototype.setPadGreen = function( pad ) {
    this.padTable[ pad * 2 ] = 127;
    this.padTable[ pad * 2 + 1 ] = 0;
};

Leds.prototype.setPadRed = function( pad ) {
    this.padTable[ pad * 2 ] = 0;
    this.padTable[ pad * 2 + 1 ] = 127;
};

Leds.prototype.setPadYellow = function( pad ) {
    this.padTable[ pad * 2 ] = 50;
    this.padTable[ pad * 2 + 1 ] = 5;
};

Leds.prototype.setPadOff = function( pad ) {
    this.padTable[ pad * 2 ] = 0;
    this.padTable[ pad * 2 + 1 ] = 0;
};


/**
 * Sets the led for pads using color in this.padTable.
 * @param min first pad (0..32)
 * @param max last pad (0..32)
 */
Leds.prototype.setPads = function( min, max )
{
    min = min || 0;
    max = max || 16;

    for( i = min; i < max; i++ ) {
        var index = i * 2;
        app.sendMidi( 144, index, this.padTable[ index ]);
        app.sendMidi( 144, index + 1, this.padTable[ index + 1 ]);
    }
};


Leds.prototype.setLed = function( num, value )
{
    app.sendMidi( 144, num, value );
};


Leds.prototype.setLeds = function( min, max, value )
{
    min = min || 0;
    max = max || 128;

    for( var i = min; i < max; i++ ) {
        app.sendMidi( 144, i, value );
    }
};


//Leds.prototype.setPairSensor = function( sensor )  // TODO: handle this in sensors.js
//{
//    var outCodes = sensor.getOutCodes();
//    var inCodes  = sensor.getInCodes();
//    this.setLed( inCodes.dec, outCodes.dec );
//    this.setLed( inCodes.inc, outCodes.inc );
//};


//Leds.prototype.setModeSensor = function()
//{
//    var code = app.preferences.mode === 'notes' ? 44 : 45;
//    this.setLed( code, 127 );
//};




Leds.prototype.setSlider = function( slider, value )
{
    app.sendMidi( 176, slider, value );
};



