/**
 * Observer mixin
 */

var Observer = {
    addListener: function( what, context, callback )
    {
        if( this.listeners[what] === undefined ) {
            this.listeners[what] = [];
        }
        var length = this.listeners[what].length;
        this.listeners[what][length] = {
            callback: callback,
            context: context
        };
    },
    //removeListener: function( what, callback ) {
    //    for (var i = 0; i < this.listeners.length; i++) {
    //        if (this.listeners[i] === callback) {
    //            delete(this.listeners[i]);
    //        }
    //    }
    //},
    fire: function( what )
    {
        var listeners = this.listeners[what];
        if( listeners !== undefined ) {
            for( var i = 0; i < listeners.length; i++ ) {
                var listener = listeners[i];
                if( typeof listener.callback === 'function' )
                {
                    listener.callback.call( listener.context, this );
                }
            }
        }
    },
    makeObserver: function( o ) { // turns an object into an observer
        for( var i in this ) {
            o[i] = this[i];
            o.listeners = {};
        }
    }
};
