

/**
 * Prints incoming midi events to the console
 * @param midi {MidiData}
 */
var MidiMonitor = function()
{
    app.preferences.addListener( 'monitorEnabled', this, function() {
        app.message( 'Monitor: ' + (app.preferences.monitorEnabled ? 'On' : 'Off' ));
    });
};


MidiMonitor.prototype.onMidi = function( midi )
{
    if( app.preferences.monitorEnabled === false ) return;

    var typeString = midi.typeString();
    var channel    = midi.channel();
    var msg        = 'Quneo_E3 Monitor: ' + typeString + ': ';
    msg            += midi.data1 + '  val: ' + midi.data2 + '  ch: ' + channel;
    msg            += ' [ ' + midi.toString() + ']';

    println( msg );
};


