/**
 * Pitchbend
 * Handles the pitchbend slider.
 *
 * @author 3ears
 * @mail tom-buettner@t-online.de
 */
var PitchbendSlider = function() {
    this.sensors.pitchbend = new Slider( 'pitchbend' );
};
PitchbendSlider.prototype = new SensorGroup();
PitchbendSlider.prototype.constructor = PitchbendSlider;


PitchbendSlider.prototype.onNoteOff = function( midi )
{
    if( midi.data1 === app.layout.pitchbend.note ) {
        var sensor = this.sensors.pitchbend;
        sensor.setValue( 0 );
        sensor.onRelease();
        this.sendToBitwig( 64 );
    }
};


PitchbendSlider.prototype.onController = function( midi )
{
    if( midi.data1 === app.layout.pitchbend.cc ) {
        this.sensors.pitchbend.onMove( midi.data2 );
        this.sendToBitwig();
    }
};


PitchbendSlider.prototype.sendToBitwig = function( value )
{
    value = value || this.sensors.pitchbend.getValue();
    var data  = MidiData.encode14BitValue( value );

    app.midiToBitwig( 0xE0, data.msb, data.lsb );
};
