
/**
 * TrackButton
 * Handles the track selector buttons.
 * @author 3ears
 * @mail tom-buettner@t-online.de
 */
var TrackButton = function()
{
    var self   = this;
    this.sensors.track = new AutomatedSensorPair( 'trackUp', 'trackDown' );

    this.sensors.track.addListener( 'sensorInc', this, function() {
        app.cursorTrack.selectNext();
    });
    this.sensors.track.addListener( 'sensorDec', this, function() {
        app.cursorTrack.selectPrevious();
    });
    app.cursorTrack.addCanSelectPreviousObserver( function( canSelect ) {
        self.sensors.track.enableDecrease( canSelect, self.isActive() );
    });
    app.cursorTrack.addCanSelectNextObserver( function( canSelect ) {  // not working, seems buggy
        //sensors.track.enableIncrease( canSelect );
    });
    this.sensors.track.enableIncrease( true );  // workaround, always enable increase
};
TrackButton.prototype = new SensorGroup();
TrackButton.prototype.constructor = TrackButton;


TrackButton.prototype.onNoteOn = function( midi )
{
    switch( midi.data1 ) {
        case app.layout.trackUp.note   : this.sensors.track.increase(); break;
        case app.layout.trackDown.note : this.sensors.track.decrease(); break;
    }
};


TrackButton.prototype.onNoteOff = function( midi )
{
    switch( midi.data1 ) {
        case app.layout.trackUp.note   :
        case app.layout.trackDown.note : this.sensors.track.onRelease(); break;
    }
};


TrackButton.prototype.permittedModes = ['notes', 'clips', 'split'];
