/**
 * TransportButtons
 * @author 3ears
 * @mail tom-buettner@t-online.de
 */
var TransportButtons = function()
{
    var self = this;
    self.sensors.start  = new Sensor( 'transportStart' );
    self.sensors.stop   = new Sensor( 'transportStop' );
    self.sensors.record = new Sensor( 'transportRecord' );

    this.hostTransport = host.createTransport();
    this.hostTransport.addIsPlayingObserver( function( playing ) {
        self.sensors.start.setValue( playing, self.isActive() );
        self.sensors.stop.setValue( !playing, self.isActive() );
    });
    this.hostTransport.addIsRecordingObserver( function( recording ) {
        self.sensors.record.setValue( recording, self.isActive() );
    });
};
TransportButtons.prototype = new SensorGroup();
TransportButtons.prototype.constructor = TransportButtons;


TransportButtons.prototype.onNoteOn = function( midi )
{
    switch( midi.data1 ) {
        case app.layout.transportStart.note  : this.hostTransport.play(); break;
        case app.layout.transportStop.note   : this.hostTransport.stop(); break;
        case app.layout.transportRecord.note : this.hostTransport.record(); break;
    }
};

TransportButtons.prototype.onNoteOff = function( midi )
{
    switch( midi.data1 ) {
        case app.layout.transportStart.note  : this.sensors.start.onRelease(); break;
        case app.layout.transportStop.note   : this.sensors.stop.onRelease(); break;
        case app.layout.transportRecord.note : this.sensors.record.onRelease(); break;
    }
};

TransportButtons.prototype.permittedModes = ['notes', 'clips', 'split'];
