

var utils = {


    bind: function( fn, scope )
    {
        if( typeof fn === 'function' ) {
            return function () {
                return fn.apply( scope, arguments );
            }
        }
        else throw 'e3_utils.bind(): ' + fn + ' is not a function';
    },


    dumpObject: function( obj, comment )
    {
        var result = '';
        comment = comment || '';
        var isUndefined = typeof obj === 'undefined' ? 'undefined' : '';
        var isNull = obj == null ? 'null' : '';

        result += comment + isUndefined + ' ' + isNull + '\n';
        for( var prop in obj ) {
            println( 'dumpObject prop='+prop );
            //if( obj.hasOwnProperty && obj.hasOwnProperty( prop )) {
                //if( typeof value === 'function' ) value = '[function]';
                if( typeof value !== 'function' ) {
                    var value = obj[prop];
                    result += prop + ' = ' + value + '\n';
                }
            //}
        }
        return result;
    }
};


String.prototype.capitalize = function() {
    return this.charAt(0).toUpperCase() + this.slice(1);
};



/**
 * Observer mixin
 */

var Observer = {
    addListener: function( what, context, callback )
    {
        if( this.listeners[what] === undefined ) {
            this.listeners[what] = [];
        }
        var length = this.listeners[what].length;
        this.listeners[what][length] = {
            callback: callback,
            context: context
        };
    },
    fire: function( what )
    {
        if( this.canFire ) {
            var listeners = this.listeners[what];
            if( listeners !== undefined ) {
                for( var i = 0; i < listeners.length; i++ ) {
                    var listener = listeners[i];
                    if( typeof listener.callback === 'function' )
                    {
                        listener.callback.call( listener.context, this, what );
                    }
                }
            }
        }
    },
    makeObserver: function( o ) // turns an object into an observer
    {
        for( var i in this ) {
            o[i] = this[i];
            o.listeners = {};
        }
    },
    canFire: true
};


