/**
 * VolumeRotaryGroup
 * @author 3ears
 * @mail tom-buettner@t-online.de
 */
var VolumeRotaryGroup = function()
{
    var sensors = this.sensors;
    sensors.masterVolume = new Rotary( 0, 127, 'masterVolume' );
    sensors.trackVolume  = new Rotary( 0, 127, 'trackVolume' );

    var trackVolume  = app.cursorTrack.getVolume();
    var masterVolume = app.masterTrack.getVolume();

    trackVolume.addValueObserver( 128, function( volume ) {
        sensors.trackVolume.setValue( volume, true );
    });
    sensors.trackVolume.addListener( 'sensorMove', this, function( sensor ) {
        trackVolume.set( sensor.getValue(), 128 );
    });

    masterVolume.addValueObserver( 128, function( volume ) {
        sensors.masterVolume.setValue( volume, true );
    });
    sensors.masterVolume.addListener( 'sensorMove', this, function( sensor ) {
        masterVolume.set( sensor.getValue(), 128 );
    });
};
VolumeRotaryGroup.prototype = new SensorGroup();
VolumeRotaryGroup.prototype.constructor = VolumeRotaryGroup;


VolumeRotaryGroup.prototype.onController = function( midi )
{
    switch( midi.data1 ) {
        case app.layout.masterVolume.cc : this.sensors.masterVolume.onMove( midi.data2 ); break;
        case app.layout.trackVolume.cc  : this.sensors.trackVolume.onMove( midi.data2 ); break;
    }
};


VolumeRotaryGroup.prototype.onNoteOff = function( midi )
{
    switch( midi.data1 ) {
        case app.layout.masterVolume.note : this.sensors.masterVolume.onRelease( midi.data2 ); break;
        case app.layout.trackVolume.note  : this.sensors.trackVolume.onRelease( midi.data2 ); break;
    }
}

VolumeRotaryGroup.prototype.permittedModes = ['notes', 'clips', 'split' ];


